package edu.cmu.mse.vault.account;

import java.io.Serializable;

/**
 * @author Soumya
 *
 */
public class Account implements Serializable {
    
    private Double balance; 
    
    /** You donot have to set the account id or customer id when you *create* the account
     *  becuase acountId is a auto-generated field in the database. But you still have to 
     *  get the account id when you want to show information about the user.  */
    private Integer accountId;
    private Integer customerId; 
    
    /**
     * The customer (customerid) for whom you want to 
     * create the account must be specified when you create the account information 
     * The account number (accountid) will be generated by the database automatically 
     * @param customerId
     * @param balance
     */
    public Account(Integer custId, Double bal)
    {
        this.customerId = custId;
        this.balance = bal;

    }
    
    /**
     * This is used by the session ejb method that wants to returns the result of 
     * of a search to the cleint. 
     * 
     * @param custId
     * @param accountId
     * @param balance
     */
    public Account(Integer custId, Integer actId, Double bal  )
    {
        this.customerId = custId;
        this.accountId = actId;
        this.balance = bal;
        
    }
    
    
    /**
     * @return Returns the accountId.
     */
    public Integer getAccountId() {
        return accountId;
    }
    /**
     * IMP: You don't need to set the accountId when you are creating the us
     * @param accountId The accountId to set.
     */
    public void setAccountId(Integer accountId) {
        this.accountId = accountId;
    }
    /**
     * @return Returns the balance.
     */
    public Double getBalance() {
        return balance;
    }
    /**
     * @param balance The balance to set.
     */
    public void setBalance(Double balance) {
        this.balance = balance;
    }
    /**
     * @return Returns the customerId.
     */
    public Integer getCustomerId() {
        return customerId;
    }
    /**
     * @param customerId The customerId to set.
     */
    public void setCustomerId(Integer customerId) {
        this.customerId = customerId;
    }
}
