package edu.cmu.mse.vault.client;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import edu.cmu.mse.vault.message.Message;
import edu.cmu.mse.vault.message.MessageKey;
import edu.cmu.mse.vault.transaction.TransactionAgentSession;
import edu.cmu.mse.vault.transaction.TransactionAgentSessionHome;
import edu.cmu.mse.vault.transaction.TransactionRow;
import edu.cmu.mse.vault.util.VaultUtil;

/**
 * @author Soumya
 *  
 * Is a test client to see if the JNDI clien
 */
public class JNDITestClient {

	public static void main(String[] args) {

		System.out.println("JNDITestClient client invoked ...");


		JNDITestClient client = new JNDITestClient();
		System.out.println("args[0]:" + args[0]);
		System.out.println("args[1]:" + args[1]);
		if( args.length > 2 ) 
		      System.out.println("args[2]:" + args[2]);
		if (args.length > 3)
			System.out.println("args[3]:" + args[3]);

		boolean result = false;
/*		if (args[0].equals("addcustomer"))
			result = client.addCustomer(args[1], args[2]);
		else if (args[0].equals("editcustomer"))
			result = client.editCustomer(args[1], args[2], args[3]);
		else if (args[0].equals("addaccount"))
			result = client.addAccount(args[1], args[2]);
		else if (args[0].equals("deposit"))
			result = client.deposit(args[1], args[2], true);
		else if (args[0].equals("withdraw"))
			result = client.deposit(args[1], args[2], false);
		else if (args[0].equals("transfer"))
			result = client.transfer(args[1], args[2], args[3]);
*/
		if (args[0].equals("history"))
			result = client.testJndiAndIsAlive(args[1]);
		

		if (result)
			System.out.println("The operation completed successfully ....");
		else
			System.out
					.println("The operation couldn't complete successfully ..... ");

	}

	/**
	 * Chagned the transactionHistory method to take into two params 
	 * @param accountId
	 * @param replica
	 * @return
	 */
	private boolean testAccountHistory(String accountId, String replicaId) {
		if (VaultUtil.isNullOrBlank(accountId)) {
			System.out.println("The account id cannot be blank ...");
			return false;
		}
		
		int iAccountId = -1;
		
		//get the number values from the strings passed
		try {

			iAccountId = Integer.parseInt(accountId);
			
		} catch (NumberFormatException nfe) {

			System.out.println("The account id passed " + accountId + " is not a number ");
			return false;

		}
		
		boolean status = false;

		try {
		        
			System.out.println("-DEBUG- Inside showTransactionHistory()  is trying to get the Initial context..." );
			InitialContext jndiContext = getGlobalInitialContext();
			//System.out.println("-DEBUG- Inside showTransactionHistory() ( initialContext == null ) is ..." + (initialContext == null));
                       
		        //lookup the JNDI context 
                        //Context jndiContext = (Context) initialContext.lookup("external/jndi/jboss1");

			System.out.println("-DEBUG- Inside showTransactionHistory() ( jndiContext == null ) is ..." + (jndiContext == null));
			
			//FIX: This is just for testing. 
			//replica id will be 1 or 2 external/jndi/jboss1/TransactionAgentSessionEJB
			String fullJNDIName = "external/jndi/jboss"+ replicaId + "/TransactionAgentSessionEJB";
			
			Object ref = jndiContext.lookup(fullJNDIName);
			System.out.println("-DEBUG- Inside showTransactionHistory() done with the lookup() ..." );
			TransactionAgentSessionHome home = (TransactionAgentSessionHome) PortableRemoteObject
					.narrow(ref, TransactionAgentSessionHome.class);

			TransactionAgentSession accountSession = home.create();
			
			//Check for isAlive method on Transaction Session EJB. 
			System.out.println("TransactionAgentSession.isAlive() is " + accountSession.isAlive() + " for replica " + replicaId );
			
			//List transactionData = accountSession.getTransactionHistory( iAccountId );
			List transactionData = ((List)((Message)accountSession.getTransactionHistory(nextKey(), iAccountId)).getPayload());
			Iterator iter = transactionData.iterator();
			TransactionRow currentRow = null;
			while (iter.hasNext()) {
				currentRow = (TransactionRow) iter.next();
				System.out.println(currentRow.toString());
			}
			status = true;

		} catch (java.rmi.RemoteException re) {
			status = false;
			re.printStackTrace();
		} catch (javax.naming.NamingException ne) {
			status = false;
			ne.printStackTrace();
		} catch (javax.ejb.CreateException ce) {
			status = false;
			ce.printStackTrace();
		} 
		
		return status;

	}

	public static Context getInitialContext()
			throws javax.naming.NamingException {
		return new InitialContext();

	}


	public static InitialContext getGlobalInitialContext()
			throws javax.naming.NamingException {
		return new InitialContext();

        }

	public boolean testJndiAndIsAlive(String accountId) {
        
        boolean result1 = testAccountHistory(accountId, "1");
        boolean result2 = testAccountHistory(accountId, "2");
        
        return (result1 && result2); 
    }

	public MessageKey nextKey() {
		MessageKey mk = null;
		try {
			FileReader fr = new FileReader(cfgFn);
			BufferedReader br = new BufferedReader(fr);
			String clientID = br.readLine();
			int seqNum = Integer.parseInt(br.readLine());
			br = null;
			fr.close();
			fr = null;
			
			mk = new MessageKey(clientID, seqNum);
			System.out.println("nextKeyCreated with value: (" + clientID + ", " + seqNum + ")");
			seqNum++;
			
			FileWriter fw = new FileWriter(cfgFn);
			BufferedWriter bw = new BufferedWriter(fw);
			bw.write(clientID);
			bw.newLine();
			bw.write(Integer.toString(seqNum));
			bw.newLine();
			bw.flush();
			bw = null;
			fw.close();
			fw = null;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
		return mk;
	}

	public static final String cfgFn = "VaultClient.cfg";

}
