/*
 * Created on Mar 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cmu.mse.vault.client;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Timer;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

/**
 * @author Jinhee Lee
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class VaultFTBaseIClient implements Runnable {

    static Logger logger = Logger.getLogger(VaultFTBaseIClient.class.getName());
    
	private Thread thread;

	int totalSuccess;

	private final BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));

	private final PrintStream stdout = System.out;

	private final PrintStream stderr = System.err;

	private static final int PERIOD_CHECK_TRANSACTION_RESULT = 100;
	private static final int TIMEOUT_CHECK_TRANSACTION_RESULT = 600;
	
	private static final int MENU_ID_OFFSET = 0;

	private static final int MENU_ITEM_OFFSET = 1;

	private static final int CLASS_OFFSET = 2;

	private static final int METHOD_OFFSET = 3;

	private static final String[][] PROMPT = {
			{ "1", "Add Customer",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"addCustomer", "First Name: ", "Last Name: " },
			{ "2", "Edit Customer",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"editCustomer", "Customer ID: ", "First Name: ",
					"Last Name: " },
			{ "3", "Create Account",
					"edu.cmu.mse.vault.client.VaultFTBaseClient", "addAccount",
					"Customer ID: ", "Starting Balance: " },
			{ "4", "Deposit Amount",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"depositMoney", "Account ID: ", "Deposit Amount: " },
			{ "5", "Withdraw Amount",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"withdrawMoney", "Account ID: ", "Withdrawal Amount: " },
			{ "6", "Transfer Amount",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"transferMoney", "From Account ID: ", "To Account ID: ",
					"Transfer Amount: " },
			{ "7", "Show Transaction History",
					"edu.cmu.mse.vault.client.VaultFTBaseClient",
					"showTransactionHistory", "Account ID: " }, { "Q", "Quit" } };

	/**
	 *  
	 */
	public VaultFTBaseIClient() {
		thread = new Thread(this);
		thread.start();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try {
			String menuChoice;
			String menuQuit = PROMPT[PROMPT.length - 1][MENU_ID_OFFSET]
					.toUpperCase();

			HashMap prompts = new HashMap(PROMPT.length);
			for (int i = 0; i < PROMPT.length - 1; i++) {
				prompts.put((Object) PROMPT[i][MENU_ID_OFFSET],
						(Object) PROMPT[i]);
			}

			String[] argPrompts;
			ArrayList argList;
			ArrayList argTypeList;
			String[] args;

			stdout.println("Welcome to the Faultless Vault FT Baseline system!");
			do {
				printMenu(stdout);
				menuChoice = promptInput(stdin, stdout, "Selection: ");

				if ((menuChoice == null) || (menuChoice.length() == 0)) {
					continue;
				}
				menuChoice = menuChoice.toUpperCase();
				if (menuChoice.equals(menuQuit)) {
					break;
				}

				argPrompts = (String[]) prompts.get(menuChoice);

				argList = new ArrayList(argPrompts.length - METHOD_OFFSET);
				argList.add(argPrompts[METHOD_OFFSET]);
				for (int i = METHOD_OFFSET + 1; i < argPrompts.length; i++) {
					argList.add(promptInput(stdin, stdout, argPrompts[i]));

				}
				args = (String[]) argList.toArray(new String[] {});

				int numInstances = VaultFTBaseClient.vjc
						.getNUM_SERVER_INSTANCES();
				
				if (numInstances <= 0) {
					logger.warn("Number of current active server instances is 0 or less");
					break;
				}
				//int numInstances = 3;
				//System.out.println("numInstances" + numInstances);
				VaultWorkThread[] workThread = new VaultWorkThread[numInstances];
				//System.out.println("Number of thread =" + workThread.length);
				/*
				 * Create the workthread to process the transaction for all
				 * server replica
				 */
				long theInitTime = System.currentTimeMillis();

				logger.info("Starting threads: " + Long.toString(theInitTime) );
				for (int j = 0; j < numInstances; j++) {
					int refID = j + 1;
					workThread[j] = new VaultWorkThread(args, refID);
				}
				logger.debug("Number of workthreads =" + workThread.length);

				int timeout = 0;
				int j = 0;
				do {
					
					/*
					 * Wait for a while  
					 */
					if (j == 0) {
						Thread.sleep(PERIOD_CHECK_TRANSACTION_RESULT);
						timeout += PERIOD_CHECK_TRANSACTION_RESULT;
					}
					
					//System.out.println("Value of index = " + j);
					System.out.print(".");
					
					/*
					 * Check whether workThreads are done  
					 */
					if (workThread[j].isSuccess()){
						/*
						 * if one of the threads returns the result, stop waiting
						 */
						//if (workThread[j].isResult()){
						    long endingTime = System.currentTimeMillis();
						    logger.info("Elapsed time: " + Long.toString(endingTime - theInitTime) );
							break;
						//}
					} else
						j = (++j) % numInstances;
					
				} while (timeout <= TIMEOUT_CHECK_TRANSACTION_RESULT);

				System.out.println("");
				if (timeout > TIMEOUT_CHECK_TRANSACTION_RESULT){
					logger.debug("All replicated transactions are timed out");
				    long endingTime = System.currentTimeMillis();
				    logger.info("Elapsed time: " + Long.toString(endingTime - theInitTime) );
				}
				else {
					
					int refID = j + 1;
					logger.debug("One of the WorkThreads returns result successfully. ReferenceID: " + refID);
					
					if (workThread[j].isSuccess()) {
					    logger.debug(workThread[j].getMenuChoice() + (workThread[j].isResult() ? " is done successfully" : " is failed"));
						//break;
					}

				}

			} while (true);
			System.out.println("Thank you");
		} catch (IOException ioex) {
			logger.warn("IOException at Run()");
			ioex.printStackTrace();
		} catch (InterruptedException e) {
		    logger.warn("InterruptedException at Run()");
			e.printStackTrace();
		}

	}

	/**
	 * @param out
	 */
	private void printMenu(PrintStream out) {
		out.println("Main menu:");
		for (int i = 0; i < PROMPT.length; i++) {
			out.println("[" + PROMPT[i][MENU_ID_OFFSET] + "] "
					+ PROMPT[i][MENU_ITEM_OFFSET]);
		}
		out.println();
	}

	/**
	 * @param in
	 * @param out
	 * @param prompt
	 * @return
	 * @throws IOException
	 */
	private String promptInput(BufferedReader in, PrintStream out, String prompt)
			throws IOException {
		out.print(prompt);
		out.flush();
		return in.readLine();
	}

	public static void main(String[] args) {
	    
	    PropertyConfigurator.configure("log4j.config");

		// Create a CacheManager thread
		VaultFTBaseClient.vjc = new VaultJNDICacheManager();
		
		// Create a main client thread
		VaultFTBaseIClient vfc = new VaultFTBaseIClient();
	}
}
