package edu.cmu.mse.vault.client;

import java.io.*;
import java.util.HashMap;
import java.util.ArrayList;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

public class VaultIClient implements Runnable {
    
    private Thread thread;
    private final BufferedReader stdin =
        new BufferedReader(
            new InputStreamReader(System.in)
        );
    private final PrintStream stdout = System.out;
    private final PrintStream stderr = System.err;
    
    private static final int MENU_ID_OFFSET = 0;
    private static final int MENU_ITEM_OFFSET = 1;
    private static final int CLASS_OFFSET = 2;
    private static final int METHOD_OFFSET = 3;
    private static final String[][] PROMPT = {
        {"1", "Add Customer", "edu.cmu.mse.vault.client.VaultClient", "addCustomer", "First Name: ", "Last Name: "},
        {"2", "Edit Customer", "edu.cmu.mse.vault.client.VaultClient", "editCustomer", "Customer ID: ", "First Name: ", "Last Name: "},
        {"3", "Create Account", "edu.cmu.mse.vault.client.VaultClient", "addAccount", "Customer ID: ", "Starting Balance: "},
        {"4", "Deposit Amount", "edu.cmu.mse.vault.client.VaultClient", "depositMoney", "Account ID: ", "Deposit Amount: "},
        {"5", "Withdraw Amount", "edu.cmu.mse.vault.client.VaultClient", "withdrawMoney", "Account ID: ", "Withdrawal Amount: "},
        {"6", "Transfer Amount", "edu.cmu.mse.vault.client.VaultClient", "transferMoney", "From Account ID: ", "To Account ID: ", "Transfer Amount: "},
        {"Q", "Quit"}
    };
   
    public VaultIClient() {
        thread = new Thread(this);
        thread.start();
    }
    
    public void run() {
        try {
            //final int PROMPT_LENGTH = ((String[])((Object[])PROMPT)).length();
            String menuChoice;
            String menuQuit =
                PROMPT[PROMPT.length - 1][MENU_ID_OFFSET].toUpperCase();
            
            HashMap prompts = new HashMap(PROMPT.length);
            for (int i = 0; i < PROMPT.length - 1; i++) {
                prompts.put((Object)PROMPT[i][MENU_ID_OFFSET], (Object)PROMPT[i]);
            }
            
            String[] argPrompts;
            ArrayList argList;
            ArrayList argTypeList;
            String[] args;
            Class[] argTypes;
            Class vcc;
            Object vc;
            Method method;
            
            stdout.println("Welcome to the Faultless Vault system!");
            do {
                printMenu(stdout);
                menuChoice = promptInput(stdin, stdout, "Selection: ");
                
                if ((menuChoice == null) || (menuChoice.length() == 0)) {
                    continue;
                }
                menuChoice = menuChoice.toUpperCase();
                if (menuChoice.equals(menuQuit)) {
                    break;
                }
                
                argPrompts = (String[])prompts.get(menuChoice);
                vcc = Class.forName(argPrompts[CLASS_OFFSET]);
                vc = vcc.newInstance();
                argList = new ArrayList(argPrompts.length - METHOD_OFFSET - 1);
                argTypeList = new ArrayList(argPrompts.length - METHOD_OFFSET - 1);
                for (int i = METHOD_OFFSET + 1; i < argPrompts.length; i++) {
                    argList.add(promptInput(stdin, stdout, argPrompts[i]));
                    argTypeList.add(argPrompts[i].getClass());
                }
                args = (String[])argList.toArray(new String[]{});
                argTypes = (Class[])argTypeList.toArray(new Class[]{});
                method = vcc.getMethod(argPrompts[METHOD_OFFSET], argTypes);
                method.invoke(vc, args);
                
                /*
                switch (menuChoiceC) {
                    case PROMPT[0][MENU_ID_OFFSET].toUpperCase().charAt(0):
                        custFName = promptInput(stdin, stdout, );
                        custLName = promptInput(stdin, stdout, "Last Name: ");
                        vc.addCustomer(custFName, custLName);
                        break;
                    case '2':
                        custID = promptInput(stdin, stdout, "Customer ID: ");
                        custFName = promptInput(stdin, stdout, "First Name: ");
                        custLName = promptInput(stdin, stdout, "Last Name: ");
                        vc.addCustomer(custFName, custLName);
                        break;
                    case '3':
                        custID = promptInput(stdin, stdout, "Customer ID: ");
                        custFName = promptInput(stdin, stdout, "First Name: ");
                        custLName = promptInput(stdin, stdout, "Last Name: ");
                        vc.addCustomer(custFName, custLName);
                        break;
                }
                */
            } while (true);
        } catch (IOException ioex) {
            ioex.printStackTrace();
        } catch (ClassNotFoundException cnfex) {
            cnfex.printStackTrace();
        } catch (InstantiationException iex) {
            iex.printStackTrace();
        } catch (NoSuchMethodException nsmex) {
            nsmex.printStackTrace();
        } catch (IllegalAccessException iaex) {
            iaex.printStackTrace();
        } catch (InvocationTargetException itex) {
            itex.printStackTrace();
        }
    }
    
    private void printMenu(PrintStream out) {
        out.println("Main menu:");
        for (int i = 0; i < PROMPT.length; i++) {
            out.println(
                "[" +
                PROMPT[i][MENU_ID_OFFSET] +
                "] " +
                PROMPT[i][MENU_ITEM_OFFSET]
            );
        }
        out.println();
    }
    
    private String promptInput(BufferedReader in, PrintStream out, String prompt)
        throws IOException {
            out.print(prompt);
            out.flush();
            return in.readLine();
    }
    
    public static void main(String[] args) {
        VaultIClient vic = new VaultIClient();
    }
}

//end-of-file
