/*
 * Created on Mar 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cmu.mse.vault.client;

import java.rmi.RemoteException;

/**
 * @author Jinhee Lee
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class VaultWorkThread implements Runnable {

	private Thread thread;

	private String[] args;

	/**
	 * Comment for <code>refID</code> refID is the reference ID to retrieve
	 * the specific JNDI session bean name and object reference from
	 * JNDICacheManager
	 */
	private int refID;

	/**
	 * Comment for <code>result</code> result is true if the transaction is
	 * done and the result of transaction is shown correctly
	 */
	private boolean result = false;

	/**
	 * Comment for <code>success</code> success is true if there are no
	 * exceptions and errors when processing transaction
	 */
	private boolean success = false;

	private String menuChoice;

	/**
	 * @return Returns the menuChoice.
	 */
	public String getMenuChoice() {
		return this.menuChoice;
	}

	/**
	 * @param menuChoice
	 *            The menuChoice to set.
	 */
	public void setMenuChoice(String menuChoice) {
		this.menuChoice = menuChoice;
	}

	/**
	 * @return Returns the success.
	 */
	public boolean isSuccess() {
		return success;
	}

	/**
	 * @param success
	 *            The success to set.
	 */
	public void setSuccess(boolean success) {
		this.success = success;
	}

	/**
	 * @return Returns the result.
	 */
	public boolean isResult() {
		return result;
	}

	/**
	 * @param result
	 *            The result to set.
	 */
	public void setResult(boolean result) {
		this.result = result;
	}

	/**
	 * Comment for <code>vaultClient</code> VaultFTBaseClient contains all
	 * transaction methods, which are run by the WorkThread
	 */
	private VaultFTBaseClient vaultClient;

	/**
	 * VaultWorkThread constructor
	 * 
	 * @param args
	 * @param refID :
	 *            unique thread ID to retrieve the JNDI name and object
	 *            reference
	 */
	public VaultWorkThread(String[] args, int refID) {
		this.args = args;
		this.refID = refID;

		thread = new Thread(this);
		this.thread.setName("vaultworker-"+Integer.toString(refID));
		thread.start();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Runnable#run()
	 */
	public void run() {

		/*
		 * create the instance of VaultFTBaseClient class Arguement: referenceID
		 */
		vaultClient = new VaultFTBaseClient(refID);

		System.out.println("<Clienthread" + refID + ">: Method " + args[0]);
		/*
		 * set the menuChoice variable as the name of the transaction This help
		 * us to print the name of method to user screen for debugging
		 */
		this.setMenuChoice(args[0].toLowerCase());

		/*
		 * process the transaction with arguments
		 */
		if (this.getMenuChoice().equals("addcustomer"))
			this.setResult(vaultClient.addCustomer(args[1], args[2]));
		else if (this.getMenuChoice().equals("editcustomer"))
			this.setResult(vaultClient.editCustomer(args[1], args[2], args[3]));
		else if (this.getMenuChoice().equals("addaccount"))
			this.setResult(vaultClient.addAccount(args[1], args[2]));
		else if (this.getMenuChoice().equals("deposit"))
			this.setResult(vaultClient.deposit(args[1], args[2], true));
		else if (this.getMenuChoice().equals("withdraw"))
			this.setResult(vaultClient.deposit(args[1], args[2], false));
		else if (this.getMenuChoice().equals("transfer"))
			this.setResult(vaultClient.transfer(args[1], args[2], args[3]));
		else if (this.getMenuChoice().equals("history"))
			this.setResult(vaultClient.showTransactionHistory(args[1]));

		/*
		 * If no exceptions are occurred, the success flag will be set as true
		 */
		this.setSuccess(vaultClient.isSuccessfulConnection());

		if (this.isSuccess() && this.isResult())
			System.out.println("<ClienThread" + refID
					+ ">: The operation is completed successfully ....");
		else if (this.isSuccess() && !(this.isResult()))
			System.out.println("<ClienThread" + refID
					+ ">: The operation couldn't complete successfully ..... ");
		else if (!(this.isSuccess()))
			System.out.println("<ClienThread" + refID
					+ ">: The operation is failed .....");

	}

}