/*
 $Log: CustomerEntityBean.java,v $
 Revision 1.4  2005/03/17 05:24:39  glz
 First full FT version (no DB duplication handling yet)

 Revision 1.3  2005/03/17 02:59:38  glz
 FT changes

 Revision 1.2  2005/03/16 23:36:37  glz
 FT changes

 Revision 1.1  2005/03/15 01:17:25  ssimanta
 Imported VaultProject to FTVaultProject

 Revision 1.6  2005/02/13 21:13:39  ssimanta
 Made changes for Customer-Account (one to many relationship)

 Revision 1.5  2005/02/13 18:18:19  ssimanta
 Fixed ejbPostCreate to taken in a customer object now.

 Revision 1.4  2005/02/13 18:11:39  ssimanta
 Added the Local Interfaces and Made changes for local interfaces to all the
 classes.

 Revision 1.3  2005/02/13 03:42:47  ssimanta
 oooohhhhhhhhhh Added ejbPostCreate() too ..


 */
package edu.cmu.mse.vault.customer;

import java.rmi.RemoteException;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

/**
 * @ejb.bean name="CustomerEntity" display-name="Name for CustomerEntity"
 *           description="Description for CustomerEntity"
 *           jndi-name="ejb/CustomerEntity" type="CMP" cmp-version="2.x"
 *           view-type="both"
 */
public abstract class CustomerEntityBean implements EntityBean {

    public abstract void setFirstName(String name);

    public abstract String getFirstName();

    public abstract void setLastName(String name);

    public abstract String getLastName();

    public abstract void setCustId(Integer custId);

    public abstract Integer getCustId();

    //Defined for collection-based relationship between Customer and Account EJBs.
    //One Customer EJB can have multiple Account EJBs. 
    //Also note that we are using a Collection becuase one customer
    //can have mutliple accounts in the account table.
    public abstract Collection getAccounts();

    public abstract void setAccounts(Collection accounts);
	
    /**
     *  
     */
    public CustomerEntityBean() {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * This class returns Object becuase the id for the customer table in the
     * data base is an AUTO-INCREMENT field
     */
    public Object ejbCreate(Customer customer) throws CreateException, RemoteException {
        System.out.println("CustomerEntityBean.ejbCreate()");
        this.setFirstName(customer.getFirstName());
        this.setLastName(customer.getLastName());

        return this.getCustId();
    }

    public void ejbPostCreate(Customer customer) throws CreateException, RemoteException {
        System.out.println("CustomerEntityBean.ejbPostCreate()");
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     */
    public void ejbActivate() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     */
    public void ejbLoad() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     */
    public void ejbStore() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

}