package edu.cmu.mse.vault.message;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;

import edu.cmu.mse.vault.message.MessageKey;
import edu.cmu.mse.vault.message.UnexpectedMessageSequenceNumberException;

/**
 * EntityBean abstract class proxied by the Server remote interface
 * @version 1.0
 * @since 1.0
 * @author gzenarosa
 *
 */
public abstract class MessageEntityBean implements EntityBean {

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbLoad()
	 */
	public void ejbLoad() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbRemove()
	 */
	public void ejbRemove() throws RemoveException, EJBException,
			RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbStore()
	 */
	public void ejbStore() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
	 */
	public void setEntityContext(EntityContext arg0) throws EJBException,
			RemoteException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#unsetEntityContext()
	 */
	public void unsetEntityContext() throws EJBException, RemoteException {
		// TODO Auto-generated method stub

	}
	
	// accessor methods
	public abstract void setClientID(String clientID);
	public abstract String getClientID();
	public abstract void setSeqNum(int seqNum);
	public abstract int getSeqNum();
	public abstract void setReplyMsg(Serializable replyMsg);
	public abstract Serializable getReplyMsg();

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbCreate()
	 */
	public MessageKey ejbCreate(Message m) throws CreateException,
			UnexpectedMessageSequenceNumberException {
		
		MessageKey key = m.getKey();
		int expectedSeqNum = MessageKey.MIN_SEQ_NUM;
		try {
			expectedSeqNum = ejbHomeGetExpectedSequenceNumber(key.clientID);
		} catch (FinderException ex) {
			throw new CreateException("Unexpected javax.ejb.FinderException caught!");
		}
		
		System.out.println("seqNum(" + key.seqNum + ") ?= expectedSeqNum(" + expectedSeqNum + ")");
		if (key.seqNum != expectedSeqNum) {
			throw new UnexpectedMessageSequenceNumberException(key);
		}
		
		System.out.println("MessageEntity ejbCreate" + key.toString() + " invoked.");
		this.setClientID(key.clientID);
		this.setSeqNum(key.seqNum);
		this.setReplyMsg(m.getPayload());
		
		return key;
	}

	/* (non-Javadoc)
	 * @see javax.ejb.EntityBean#ejbCreate()
	 */
	public void ejbPostCreate(Message m) throws CreateException {
		System.out.println("MessageEntity ejbPostCreate" + m.getKey().toString() + " invoked.");
	}
	
	public int ejbHomeGetExpectedSequenceNumber(String clientID) throws FinderException {
		int expectedSeqNum = MessageKey.MIN_SEQ_NUM;
		
		Iterator it = ejbSelectMaxSequenceNumber(clientID).iterator();
		if (it.hasNext()) {
			Double d = (Double)it.next();
			if (d != null) {
				expectedSeqNum = d.intValue() + 1;
			}
		}
		
		return expectedSeqNum;
	}
	
	public abstract Collection ejbSelectMaxSequenceNumber(String clientID) throws FinderException;
	
}
