package edu.cmu.mse.vault.message;

import java.io.Serializable;

/**
 * Primary key class for the message table used by container-managed persistence
 * @version 1.0
 * @since 1.0
 * @author gzenarosa
 */
public class MessageKey implements Serializable {
	
	/**
	 * Minimum sequence number for messages
	 */
	public static final int MIN_SEQ_NUM = 1;
	
	public String clientID;
	public int seqNum;
	
	public MessageKey() {
		clientID = null;
		seqNum = 0;
	}
	
	public MessageKey(String clientID, int seqNum) {
		this.clientID = clientID;
		this.seqNum = seqNum;
	}
	
	public boolean equals(Object obj) {
		if (!(obj instanceof MessageKey))
			return false;

		MessageKey key = (MessageKey)obj;

		return clientID.equals(key.clientID) && (seqNum == key.seqNum);
	}

	public int hashCode() {
		return 65521 * clientID.hashCode() + seqNum;
	}
	
	public String toString() {
		return "(" + clientID + ", " + seqNum + ")";
	}
}
