/*
 * $Id: IVaultReplicationManager.java,v 1.1 2005/03/16 02:28:04 ssimanta Exp $
 * Copyright Soumya
 */
package edu.cmu.mse.vault.repman;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;

/**
 * @author Soumya
 *
 */
public interface IVaultReplicationManager extends Remote{
    
    /**
     * Returns a host name where the global JNDI server is running. 
     * @return
     * @throws RemoteException
     */
    public String getJNDIHostName() throws RemoteException;

    /**
     * Returns a <code>java.util.List</code> of Transaction references.
     * The client must take these values and use them to get actual object from the JNDI server.
     * @return
     * @throws RemoteException
     */
    public List getTransactionRefNames() throws RemoteException;
    
	/**
     * Returns a <code>java.util.List</code> of Account references.
     * The client must take these values and use them to get actual object from the JNDI server.
	 * @return
	 * @throws RemoteException
	 */    
    public List getAccountRefNames() throws RemoteException;
    
    /**
     * Returns a <code>java.util.List</code> of Customer references.
     * The client must take these values and use them to get actual object from the JNDI server.
 
     * @return
     * @throws RemoteException
     */
    public List getCustomerRefNames() throws RemoteException;
    
    /**
     * Returns the number of active replicas 
     * @return
     * @throws RemoteException
     */
    public int getNumberOfReplicas() throws RemoteException;
    
    /**
     * Returns number of current active replicas 
     * @return
     * @throws RemoteException
     */
    public int getCurrentActiveReplicas() throws RemoteException;

}
