/*
 * $Id: RMITestClient.java,v 1.3 2005/03/17 03:16:33 ssimanta Exp $
 * Created on Mar 16, 2005
 *
 * Copyright Soumya
 */
package edu.cmu.mse.vault.repman;

import java.util.Iterator;
import java.util.List;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

/**
 * @author Soumya
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class RMITestClient {

    private IVaultReplicationManager repManager;

    public RMITestClient(String remoteName) throws NotBoundException,
            MalformedURLException, RemoteException {

        // Get the remote reference
        this.repManager = (IVaultReplicationManager) Naming.lookup(remoteName);

        System.out.println("Got the remote reference for"
                + IVaultReplicationManager.class.getName()
                + " successfully ...");

    }

    /**
     * Prints a java.util.List containing Strings
     * 
     * @param list
     */
    private static void printRefs(List list) {
        if (list != null)
            System.out.println("The passed list is null ...");

        Iterator iter = list.iterator();
        while (iter.hasNext()) {
            System.out.println(" " + iter.next());
        }

    }

    public static void main(String args[]) {

        try {
            RMITestClient test = new RMITestClient(
                    "//drlucky.ece.cmu.edu:10001/Vault_Rep_man");
            System.out.println("The remote host name is "
                    + test.repManager.getJNDIHostName());

            List refs = test.repManager.getAccountRefNames();
            System.out.println("The account refs names are ...");
            printRefs(refs);
            refs = test.repManager.getCustomerRefNames();
            System.out.println("The cusomter refs names are ...");            
            printRefs(refs);
            System.out.println("The transaction refs names are ...");            
            refs = test.repManager.getTransactionRefNames();
            printRefs(refs);

        } catch (RemoteException re) {

            re.printStackTrace();
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (NotBoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

}