/*
 $Log: TransactionEntityBean.java,v $
 Revision 1.1  2005/03/15 01:17:23  ssimanta
 Imported VaultProject to FTVaultProject

 Revision 1.8  2005/02/16 06:12:03  jhlee1
 trial with commenting setAccountID

 Revision 1.7  2005/02/16 04:41:56  jhlee1
 *** empty log message ***

 Revision 1.6  2005/02/16 04:31:13  jhlee1
 *** empty log message ***

 Revision 1.5  2005/02/16 04:18:48  jhlee1
 *** empty log message ***

 Revision 1.4  2005/02/16 04:06:28  jhlee1
 *** empty log message ***

 Revision 1.3  2005/02/16 02:27:15  ssimanta
 Made changes for Transaction-Account relationship.

 Revision 1.2  2005/02/16 01:12:04  lmaya
 Comparing with the customer object

 Revision 1.1  2005/02/15 06:44:05  lmaya
 The deposit transaction has been added.
 */
package edu.cmu.mse.vault.transaction;

import java.rmi.RemoteException;
import java.util.Date;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

import edu.cmu.mse.vault.account.AccountEntityLocal;

/**
 * @ejb.bean name="TransactionEntity" display-name="Name for TransactionEntity"
 *           description="Description for TransactionEntity"
 *           jndi-name="ejb/TransactionEntity" type="CMP" cmp-version="2.x"
 *           view-type="both"
 */
public abstract class TransactionEntityBean implements EntityBean {

    /** Relationship methods for account-transaction relation */
	//public abstract Integer getTransID();
	 
	public abstract void setAccount(AccountEntityLocal account);

    public abstract AccountEntityLocal getAccount();

    //public abstract void setAccountID(Integer accountID);

    public abstract Date getDate();

    public abstract void setDate(Date date);

    public abstract Double getTransAmount();

    public abstract void setTransAmount(Double transAmount);

    public abstract Integer getTransferToAccount();

    public abstract void setTransferToAccount(Integer transferToAccount);

    public abstract Integer getTransType();

    public abstract void setTransType(Integer transType);

    /**
     *  
     */
    public TransactionEntityBean() {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * This class returns Object because the id for the transaction table in the
     * data base is an AUTO-INCREMENT field
     */
    public Object ejbCreate(Transaction transaction,
            AccountEntityLocal accountLocal) throws CreateException,
            RemoteException {

        //this.setAccountID(transaction.getAccountID());
    	this.setTransAmount(transaction.getTransAmount());
        this.setDate(transaction.getDate());
        this.setTransferToAccount(transaction.getTransferToAccount());
        this.setTransType(transaction.getTransType());
        
       
        System.out.println("EJB Create called : transaction");
        return null;
    }

    public void ejbPostCreate(Transaction transaction,
            AccountEntityLocal accountLocal) throws CreateException,
            RemoteException {
        System.out.println("EJB PostCreate called : transaction");
        //IMP: You have to set
        this.setAccount(accountLocal);
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     */
    public void ejbActivate() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     */
    public void ejbLoad() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     */
    public void ejbStore() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        // TODO Auto-generated method stub

    }

}